/*
 * SWFxME is an open source solution to extend Flash Lite
 * using J2ME (http server). It is developed to enrich Flash 
 * Lite with certain features which it dont have like writing to 
 * a file, listing a directory etc.Simply , 
 *          Flash Lite + J2ME  = More Fun :)
 * It is quite easy to extend SWFxME , please read documentation for more details.
 * Drop me a mail , if u have further questions or any feedback :
 * @ email : sajisoft@gmail.com
 * @ Author of SWFxME : Sajid Ali Anjum (a.k.a SajiSoft)
 * Credit also goes to : 
 * Felipe Andrade (for his Jarpa project)
 */

package SWFxME;


import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import javax.microedition.io.Connector;
import javax.microedition.io.ServerSocketConnection;
import javax.microedition.io.SocketConnection;

public class FLServer implements Runnable  {
   public static FLServer _instance;    
   public boolean _isListening = false;
    private ServerSocketConnection _server;
    private InputStream _in;
    private SocketConnection _client;
    public String _status = "";
    private OutputStream _out;
  
    SocketConnection sc;

    public static FLServer getInstance() {
        if(_instance == null) {
            _instance = new FLServer();
        }
        
        return _instance;
    }
    
    public FLServer() {
        _status = "starting";
        new Thread(this).start();

    }
    
    public String write(String aData) throws Exception {
        _status = "sending data...";
        String var ="HTTP/1.0 200 OK\r\nConnection: Close\r\n\r\n";
     //   aData += "\r\n";
        var += aData;
        
        synchronized (this) {
            if(_client != null) {
                try {               
                   _out.write(var.getBytes());
                   _out.flush();
                   
                } catch (Exception e) {
                   _status = "Send2Client Error : " + e.toString();
                }
               
            }
        }
        return aData;
    }
    
    public String read() {
		StringBuffer sb = new StringBuffer();
        synchronized (this) {
            if(_client != null) {
               while (true) {
		int c = 0;
                try 
                {
		while (((c = _in.read()) != '\n') && (c != -1)) {
		    sb.append((char) c);
		}
                if (c != -1)
                {
		 break;
                }
                _status = sb.toString();
                Thread.sleep(10);
                }  
                catch (Exception e) {
                 _status = "Recv4mClient Error : " + e.toString();
                 
                }   
               }
            }
        }
        return sb.toString();
    }
    

    
    public void close_client() {
        
                try 
                {
                _in.close();
                _out.close();
                }
                catch (Exception e) {
                _status = "Closing Client Error";
               
                }
        try {
            _client.close();
        } catch (IOException e) {
            _status = "close: " + e.toString();
        }
    }
    public void run(){}
    
    public String close_server()
    {
        _status = "";
          try
        { 
         write("&feedback=Server Closed!&");
         close_client();
        }
           catch (Exception e) {
                _status = "Closing Client Error";
                } 
    try 
    {
        
        _isListening = false;
        _server.close();
    }
     catch (Exception e) {
                _status = "Closing Server Error";
                } 
    return _status;
    }
    public void init_server(String PORT) {
        try {
            _isListening = true;
            _server = (ServerSocketConnection) Connector.open("socket://:" + PORT);
            _client = null;
            _status = "Listening...";
        } catch (Exception e) {
            _status = "Error while init server : " + e.toString();
        }

        }
    
 

public String listen(){
    String recv  = "";
    String rq = "";
        try {
            _client = (SocketConnection) _server.acceptAndOpen();
         
        }catch (Exception e) {
            _status = "Error while listening 1 : " + e.toString();
        }
        try {
          _client.setSocketOption(SocketConnection.DELAY, 0);
        
         _client.setSocketOption(SocketConnection.KEEPALIVE, 0);
            
            _out = _client.openDataOutputStream();
            _in = _client.openDataInputStream();
            recv = read();
           rq = Functions.getInstance().main_handler(recv);
            write(rq);
            close_client();
           _status = "RECIEVED : " + recv;
           _status += "--SENT : " + rq;
        } catch (Exception e) {
           _status = "Error while listening 1 :" + e.toString();
     
        }

return _status;
}
}
